Imports System.IO
Imports Telerik.WebControls
Imports Telerik.RadUploadUtils.RadControl
Imports Telerik.WebControls.RadTreeViewContextMenu

Partial Class uploadManager_default
    Inherits System.Web.UI.Page

    Protected Sub btnSubmit_Click(ByVal sender As Object, ByVal e As EventArgs)
        BindResults()
        RadAjaxManager1.AjaxSettings.AddAjaxSetting(RadTree1, FooterPanel, Nothing)
        Dim rootDir As New DirectoryInfo(Server.MapPath("../") + "/incoming")
        lblSize.Text = "Disk Space Used: " + FormatNumber((size(rootDir) / 1024), 0, TriState.False, , TriState.True).ToString + " MB"
    End Sub 'btnSubmit_Click

    Private Sub BindTreeToDirectory(ByVal dirPath As String, ByVal parentNode As RadTreeNode)
        Dim dirs As String() = Directory.GetDirectories(dirPath)
        Dim s As String
        For Each s In dirs

            Dim parts As String() = s.Split("\"c)
            Dim name As String = parts((parts.Length - 1))
            If name <> "Examples" And name <> "_vti_cnf" Then
                Dim node As New RadTreeNode(name)
                node.ImageUrl = "Folder.gif"
                node.ImageExpandedUrl = "FolderOpen.gif"
                node.Value = s
                node.Text = name
                node.Category = "Folder"
                node.ContextMenuName = "FolderContextMenu"
                parentNode.Nodes.Add(node)

                BindTreeToDirectory(s, node)
            End If
        Next s

        Dim files As String() = Directory.GetFiles(dirPath)
        Dim fileName As String
        For Each fileName In files
            Dim parts As String() = fileName.Split("\"c)
            Dim name As String = parts((parts.Length - 1))
            Dim node As New RadTreeNode(name)
            Dim fi As New FileInfo(fileName)
            Select Case LCase(fi.Extension)
                Case ".zip"
                    node.ImageUrl = "zip.gif"
                Case ".rar"
                    node.ImageUrl = "zip.gif"
                Case ".doc"
                    node.ImageUrl = "doc.gif"
                Case ".xls"
                    node.ImageUrl = "xls.gif"
                Case ".ppt"
                    node.ImageUrl = "ppt.gif"
                Case ".pdf"
                    node.ImageUrl = "pdf.gif"
                Case ".mdb"
                    node.ImageUrl = "mdb.gif"
                Case ".mdf"
                    node.ImageUrl = "mdb.gif"
                Case ".mpeg"
                    node.ImageUrl = "mpeg.gif"
                Case ".mpg"
                    node.ImageUrl = "mpeg.gif"
                Case ".avi"
                    node.ImageUrl = "mpeg.gif"
                Case ".txt"
                    node.ImageUrl = "txt.gif"
                Case ".htm"
                    node.ImageUrl = "htm.gif"
                Case ".html"
                    node.ImageUrl = "htm.gif"
                Case ".gif"
                    node.ImageUrl = "image.gif"
                Case ".jpg"
                    node.ImageUrl = "image.gif"
                Case ".jpeg"
                    node.ImageUrl = "image.gif"
                Case ".tif"
                    node.ImageUrl = "image.gif"
                Case ".tiff"
                    node.ImageUrl = "image.gif"
                Case Else
                    node.ImageUrl = "file.gif"
            End Select
            node.Value = fi.Name + "@" + fi.Length.ToString() + "@" + fi.LastWriteTime.ToString()
            node.Category = dirPath + "\" + fi.Name
            node.ContextMenuName = "FirstContextMenu"
            node.ToolTip = FormatNumber((CType(fi.Length, Double) / 1024) / 1024, 2, TriState.True, TriState.False, TriState.True).ToString + " MB"
            parentNode.Nodes.Add(node)
        Next fileName

    End Sub 'BindTreeToDirectory


    Private Sub BindResults()
        Dim resultsExist As Boolean = upload1.UploadedFiles.Count > 0
        lblNoResults.Visible = Not resultsExist
        rptReqults.Visible = resultsExist
        If resultsExist Then
            rptReqults.DataSource = upload1.UploadedFiles
            rptReqults.DataBind()
        End If
        If Not User.IsInRole("admin") Then
            Dim rootFolder As String = Server.MapPath("~/incoming/" + Profile.Company + "/")
            Dim rootNode As New RadTreeNode(rootFolder)
            RadTree1.Nodes.Clear()
            rootNode.Text = Profile.Company
            rootNode.Value = rootFolder
            rootNode.ImageUrl = "Folder.gif"
            rootNode.ImageExpandedUrl = "FolderOpen.gif"
            rootNode.Category = "Folder"
            rootNode.Expanded = True
            rootNode.ContextMenuName = "RootContextMenu"
            RadTree1.Nodes.Add(rootNode)
            BindTreeToDirectory(rootFolder, rootNode)
        Else
            Dim rootFolder As String = Server.MapPath("~/incoming/")
            Dim rootNode As New RadTreeNode(rootFolder)
            RadTree1.Nodes.Clear()
            rootNode.Text = "Company Folders"
            rootNode.Value = Server.MapPath("~/incoming/")
            rootNode.ImageUrl = "Folder.gif"
            rootNode.ImageExpandedUrl = "FolderOpen.gif"
            rootNode.Category = "Folder"
            rootNode.Expanded = True
            rootNode.ContextMenuName = "RootContextMenu"
            RadTree1.Nodes.Add(rootNode)
            BindTreeToDirectory(rootFolder, rootNode)
        End If
        Dim uploadnode As RadTreeNode = RadTree1.FindNodeByText(Profile.Company)
        uploadnode.Expanded = True

        Dim newnode As New RadTreeNode
        newnode.ImageUrl = "13Recycle.gif"
        newnode.Value = "Recycle"
        newnode.Text = "Recycle"
        newnode.Category = "Recycle"
        newnode.DragEnabled = False
        newnode.DropEnabled = True
        RadTree1.Nodes.Add(newnode)
    End Sub 'BindResults

    Protected Overrides Sub OnInit(ByVal e As EventArgs)
        InitializeComponent()
        MyBase.OnInit(e)
    End Sub 'OnInit

    Private Sub InitializeComponent()
        Dim nd As New DirectoryInfo(Server.MapPath("../") + "/incoming/" + Profile.Company.ToString)
        If Not nd.Exists Then
            nd.Create()
        End If
        Try
            If RadTree1.SelectedNode.Category = "Folder" Then
                upload1.TargetFolder = RadTree1.SelectedNode.Value
            Else
                upload1.TargetFolder = RadTree1.SelectedNode.Parent.Value
            End If
        Catch ex As Exception
            upload1.TargetFolder = "~/incoming/" + Profile.Company + "/"
        End Try
    End Sub 'InitializeComponent

    Public Function size(ByVal dirInfo As System.IO.DirectoryInfo) As Long
        Dim total As Long = 0
        For Each file As System.IO.FileInfo In dirInfo.GetFiles()
            total += file.Length
        Next
        For Each dir As System.IO.DirectoryInfo In dirInfo.GetDirectories()
            total += size(dir)
        Next
        Return total
    End Function


    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not Page.IsPostBack Then
            If Not User.IsInRole("admin") Then
                Dim rootFolder As String = Server.MapPath("~/incoming/" + Profile.Company + "/")
                Dim rootNode As New RadTreeNode(rootFolder)
                rootNode.Text = Profile.Company
                rootNode.Value = rootFolder
                rootNode.ImageUrl = "Folder.gif"
                rootNode.ImageExpandedUrl = "FolderOpen.gif"
                rootNode.Category = "Folder"
                rootNode.Expanded = True
                rootNode.ContextMenuName = "RootContextMenu"
                RadTree1.Nodes.Add(rootNode)
                BindTreeToDirectory(rootFolder, rootNode)
            Else
                Dim rootFolder As String = Server.MapPath("~/incoming/")
                Dim rootNode As New RadTreeNode(rootFolder)
                rootNode.Text = "Company Folders"
                rootNode.Value = Server.MapPath("~/incoming/")
                rootNode.ImageUrl = "Folder.gif"
                rootNode.ImageExpandedUrl = "FolderOpen.gif"
                rootNode.Category = "Folder"
                rootNode.Expanded = True
                rootNode.ContextMenuName = "RootContextMenu"
                RadTree1.Nodes.Add(rootNode)
                BindTreeToDirectory(rootFolder, rootNode)
            End If
            Dim newnode As New RadTreeNode
            newnode.ImageUrl = "13Recycle.gif"
            newnode.Value = "Recycle"
            newnode.Text = "Recycle"
            newnode.Category = "Recycle"
            newnode.DragEnabled = False
            newnode.DropEnabled = True
            RadTree1.Nodes.Add(newnode)
        End If

        Dim rootDir As New DirectoryInfo(Server.MapPath("../") + "/incoming")
        lblSize.Text = "Disk Space Used: " + FormatNumber((size(rootDir) / 1024), 2, TriState.False, , TriState.True).ToString + " MB"

        ' Files Menu
        Dim contextMenus As New ArrayList()
        Dim cm As New ContextMenu()
        cm.Name = "FirstContextMenu"
        cm.Width = 150
        contextMenus.Add(cm)
        Dim cmi1 As New ContextMenuItem("Delete File")
        cmi1.PostBack = True
        cmi1.Image = "files_delete_24.gif"
        Dim cmi2 As New ContextMenuItem("Rename File")
        cmi2.PostBack = False
        cmi2.Image = "files_write_24.gif"
        Dim cmi3 As New ContextMenuItem("Download File")
        cmi3.PostBack = True
        cmi3.Image = "files_down_24.gif"
        cm.Items.Add(cmi1)
        cm.Items.Add(cmi2)
        cm.Items.Add(cmi3)

        ' Folders Menu
        Dim FolderCm As New ContextMenu()
        FolderCm.Name = "FolderContextMenu"
        FolderCm.Width = 150
        contextMenus.Add(FolderCm)
        Dim fcmi1 As New ContextMenuItem("Delete Folder")
        fcmi1.PostBack = True
        fcmi1.Image = "folder_delete_24.gif"
        Dim fcmi2 As New ContextMenuItem("Rename Folder")
        fcmi2.PostBack = False
        fcmi2.Image = "folder_write_24.gif"
        Dim fcmi3 As New ContextMenuItem("Create New Folder")
        fcmi3.PostBack = True
        fcmi3.Image = "folder_add_24.gif"
        FolderCm.Items.Add(fcmi1)
        FolderCm.Items.Add(fcmi2)
        FolderCm.Items.Add(fcmi3)

        ' RootNode Menu
        Dim RootCm As New ContextMenu()
        RootCm.Name = "RootContextMenu"
        RootCm.Width = 150
        contextMenus.Add(RootCm)
        Dim rcmi1 As New ContextMenuItem("Create New Folder")
        rcmi1.PostBack = True
        rcmi1.Image = "folder_add_24.gif"
        RootCm.Items.Add(rcmi1)
        Dim rcmi2 As New ContextMenuItem("Expand All Folders")
        rcmi2.PostBack = False
        rcmi2.Image = "files_zoom_24.gif"
        RootCm.Items.Add(rcmi2)
        Dim rcmi3 As New ContextMenuItem("Collapse All Folders")
        rcmi3.PostBack = False
        rcmi3.Image = "files_back_24.gif"
        RootCm.Items.Add(rcmi3)

        RadTree1.ContextMenus = contextMenus
    End Sub


    Protected Sub ContextClicked(ByVal sender As Object, ByVal e As RadTreeNodeEventArgs)
        Dim thenode As RadTreeNode = RadTree1.SelectedNode
        Select Case (e.ContextMenuItemText)
            Case "Delete File"
                Dim parentfolder As String = RadTree1.SelectedNode.Parent.Text
                Dim path As String = Server.MapPath("~/incoming/") + parentfolder + "/" + thenode.Text
                File.Delete(path)
                RadTree1.SelectedNode.Parent.Nodes.Remove(RadTree1.SelectedNode)
                RadAjaxManager1.AjaxSettings.AddAjaxSetting(RadTree1, FooterPanel, Nothing)
                Dim rootDir As New DirectoryInfo(Server.MapPath("../") + "/incoming")
                lblSize.Text = "Disk Space Used: " + FormatNumber((size(rootDir) / 1024), 0, TriState.False, , TriState.True).ToString + " MB"
            Case "Delete Folder"
                Directory.Delete(thenode.Value, True)
                RadTree1.SelectedNode.Parent.Nodes.Remove(RadTree1.SelectedNode)
            Case "Create New Folder"
                Directory.CreateDirectory(thenode.Value + "\New Folder")
                AddNode(e)
        End Select
    End Sub

    Private Sub AddNode(ByVal e As RadTreeNodeEventArgs)
        Dim newNode As RadTreeNode = New RadTreeNode
        newNode.Text = "New Folder"
        newNode.EditEnabled = True
        Dim pnode As RadTreeNode = e.NodeClicked
        newNode.Value = System.Guid.NewGuid().ToString()
        newNode.ImageUrl = "Folder.gif"
        newNode.ImageExpandedUrl = "FolderOpen.gif"
        newNode.Category = "Folder"
        newNode.Expanded = True
        newNode.ContextMenuName = "FolderContextMenu"
        pnode.Nodes.Add(newNode)
        Dim strScript As String = "<script  type=text/javascript>HighlightNode('" + newNode.Value + "')</script>"
        Page.ClientScript.RegisterStartupScript(Page.GetType(), "ScriptKey", strScript)
    End Sub


    Protected Sub RadTree1_NodeDrop(ByVal o As Object, ByVal e As Telerik.WebControls.RadTreeNodeEventArgs)
        Dim dragFrom As RadTreeNode = e.SourceDragNode
        Dim dragTo As RadTreeNode = e.DestDragNode


        If dragTo.Category = "Recycle" And dragFrom.Category = "Folder" Then
            Dim path = dragFrom.Value
            If Directory.Exists(path) Then
                Directory.Delete(path, True)
                dragFrom.Parent.Nodes.Remove(dragFrom)
                Return
            End If
        End If

        If dragTo.Category = "Recycle" And dragFrom.Category <> "Folder" Then
            Dim path = dragFrom.Category
            If File.Exists(path) Then
                File.Delete(path)
                dragFrom.Parent.Nodes.Remove(dragFrom)
                RadAjaxManager1.AjaxSettings.AddAjaxSetting(RadTree1, FooterPanel, Nothing)
                Dim rootDir As New DirectoryInfo(Server.MapPath("../") + "/incoming")
                lblSize.Text = "Disk Space Used: " + FormatNumber((size(rootDir) / 1024), 0, TriState.False, , TriState.True).ToString + " MB"
                Return
            End If
        End If


        If dragTo.Category = "Folder" And dragFrom.Category <> "Folder" And dragFrom.Parent.Text <> dragTo.Text And dragTo.Text <> "Company Folders" Then
            Dim path1 = dragFrom.Category
            Dim path2 = dragTo.Value + "/" + dragFrom.Text
            If File.Exists(path1) And Not File.Exists(path2) Then
                File.Move(path1, path2)
                Dim node As New RadTreeNode
                node.ImageUrl = dragFrom.ImageUrl
                node.Value = dragFrom.Value
                node.Category = path2
                node.ContextMenuName = dragFrom.ContextMenuName
                node.Text = dragFrom.Text
                node.ToolTip = dragFrom.ToolTip
                dragTo.Nodes.Add(node)
                dragFrom.Parent.Nodes.Remove(dragFrom)
                Return
            End If
        End If

    End Sub

    Protected Sub RadTree1_NodeEdit(ByVal o As Object, ByVal e As Telerik.WebControls.RadTreeNodeEventArgs)
        Dim nodeEdited As RadTreeNode = e.NodeEdited
        Dim oldText As String = nodeEdited.Text
        Dim newText As String = e.NewText

        Select Case (nodeEdited.Category)
            Case "Folder"
                Dim path1 As String = nodeEdited.Parent.Value + "\" + nodeEdited.Text
                Dim path2 As String = Replace(path1, nodeEdited.Text, newText)
                If path1 <> path2 Then
                    Directory.Move(path1, path2)
                    nodeEdited.Text = newText
                    nodeEdited.Value = path2
                End If
            Case Else
                Dim parentfolder As String = RadTree1.SelectedNode.Parent.Text
                Dim path1 As String = nodeEdited.Parent.Value + "/" + oldText
                Dim path2 As String = nodeEdited.Parent.Value + "/" + newText
                File.Move(path1, path2)
                nodeEdited.Text = newText
                nodeEdited.Category = path2
        End Select
    End Sub

    Protected Sub RadTree1_NodeClick(ByVal o As Object, ByVal e As Telerik.WebControls.RadTreeNodeEventArgs) Handles RadTree1.NodeClick
        If RadTree1.SelectedNode.Category = "Folder" Then
            Dim pos As Integer = InStr(RadTree1.SelectedNode.Value, "\incoming") + 9
            Dim path As String = "~/incoming" + Mid(RadTree1.SelectedNode.Value, pos) + "/"
            path = Replace(path, "\", "/")
            upload1.TargetFolder = path
        Else
            Dim pos As Integer = InStr(RadTree1.SelectedNode.Parent.Value, "\incoming") + 9
            Dim path As String = "~/incoming" + Mid(RadTree1.SelectedNode.Parent.Value, pos) + "/"
            path = Replace(path, "\", "/")
            upload1.TargetFolder = path
        End If
    End Sub
End Class